package net.sf.saxon;
import net.sf.saxon.om.NamePool;
import net.sf.saxon.om.DocumentInfo;
import net.sf.saxon.event.Sender;
import net.sf.saxon.event.Receiver;
import net.sf.saxon.event.ResultWrapper;
import net.sf.saxon.event.NamespaceReducer;

import javax.xml.transform.Source;
import javax.xml.transform.Result;
import javax.xml.transform.TransformerException;

class IdentityTransformer extends Controller {

    protected IdentityTransformer(Configuration config) {
        super(config);
    }

    /**
    * Perform identify transformation from Source to Result
    */

    public void transform(Source source, Result result)
    throws TransformerException {
        NamePool pool = NamePool.getDefaultNamePool();
        if (source instanceof DocumentInfo) {
            pool = ((DocumentInfo)source).getNamePool();
        }
        OutputURIResolver resolver = getConfiguration().getOutputURIResolver();
        Receiver receiver = ResultWrapper.getReceiver(
                result, resolver, pool, getOutputProperties(), null);
        NamespaceReducer reducer = new NamespaceReducer();
        reducer.setUnderlyingReceiver(receiver);
        new Sender(getConfiguration()).send(source, reducer, pool, false);
    }

}

//
// The contents of this file are subject to the Mozilla Public License Version 1.0 (the "License");
// you may not use this file except in compliance with the License. You may obtain a copy of the
// License at http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied.
// See the License for the specific language governing rights and limitations under the License.
//
// The Original Code is: all this file.
//
// The Initial Developer of the Original Code is
// Michael Kay of Software AG (michael.h.kay@ntlworld.com).
//
// Portions created by (your name) are Copyright (C) (your legal entity). All Rights Reserved.
//
// Contributor(s): None
//
