package net.sf.saxon.style;
import net.sf.saxon.om.NamePool;
import net.sf.saxon.om.NamespaceConstant;

public class StandardNames {

	/**
	* Well-known names used in XSLT processing
	*/

		//public int XML_SPACE;
		//public int XML_LANG;

        public int XSL_ANALYZE_STRING;
	    public int XSL_APPLY_IMPORTS;
	    public int XSL_APPLY_TEMPLATES;
        public int XSL_ATTRIBUTE;
        public int XSL_ATTRIBUTE_SET;
        public int XSL_CALL_TEMPLATE;
        public int XSL_CHARACTER_MAP;
        public int XSL_CHOOSE;
        public int XSL_COMMENT;
        public int XSL_COPY;
        public int XSL_COPY_OF;
        public int XSL_DECIMAL_FORMAT;
        public int XSL_ELEMENT;
        public int XSL_FALLBACK;
        public int XSL_FOR_EACH;
        public int XSL_FOR_EACH_GROUP;
        public int XSL_FUNCTION;
        public int XSL_IF;
        public int XSL_IMPORT;
        public int XSL_INCLUDE;
        public int XSL_KEY;
        public int XSL_MATCHING_SUBSTRING;
        public int XSL_MESSAGE;
        public int XSL_NEXT_MATCH;
        public int XSL_NUMBER;
        public int XSL_NAMESPACE;
        public int XSL_NAMESPACE_ALIAS;
        public int XSL_NON_MATCHING_SUBSTRING;
        public int XSL_OTHERWISE;
        public int XSL_OUTPUT;
        public int XSL_OUTPUT_CHARACTER;
        public int XSL_PARAM;
        public int XSL_PERFORM_SORT;
        public int XSL_PRESERVE_SPACE;
        public int XSL_PROCESSING_INSTRUCTION;
        public int XSL_RESULT_DOCUMENT;
        public int XSL_SEQUENCE;
        public int XSL_SORT;
//        public int XSL_SORT_KEY;
        public int XSL_STRIP_SPACE;
        public int XSL_STYLESHEET;
        public int XSL_TEMPLATE;
        public int XSL_TEXT;
        public int XSL_TRANSFORM;
        public int XSL_VALUE_OF;
        public int XSL_VARIABLE;
        public int XSL_WITH_PARAM;
        public int XSL_WHEN;

        public int SAXON_ASSIGN;
        public int SAXON_CALL_TEMPLATE;
        public int SAXON_COLLATION;
        public int SAXON_DOCTYPE;
        public int SAXON_ENTITY_REF;
        public int SAXON_IMPORT_QUERY;
        public int SAXON_SCRIPT;
        public int SAXON_WHILE;

        public int ARCHIVE;
        public int AS;
		public int CASE_ORDER;
		public int CDATA_SECTION_ELEMENTS;
		public int CHARACTER;
		public int CLASS;
		public int COLLATION;
		public int COPY_NAMESPACES;
		public int COUNT;
		public int DATA_TYPE;
		public int DECIMAL_SEPARATOR;
		public int DECOMPOSITION;
		public int DEFAULT;
		public int DIGIT;
		public int DISABLE_OUTPUT_ESCAPING;
		public int DOCTYPE_PUBLIC;
		public int DOCTYPE_SYSTEM;
		public int ELEMENTS;
		public int ESCAPE_URI_ATTRIBUTES;
		public int ENCODING;
		public int EXCLUDE_RESULT_PREFIXES;
		public int EXTENSION_ELEMENT_PREFIXES;
		public int FLAGS;
		public int FORMAT;
		public int FROM;
		public int GROUP_ADJACENT;
		public int GROUP_BY;
		public int GROUP_ENDING_WITH;
		public int GROUP_STARTING_WITH;
		public int GROUPING_SEPARATOR;
		public int GROUPING_SIZE;
		public int HREF;
		public int ID;
		public int IMPLEMENTS_PREFIX;
		public int INCLUDE_CONTENT_TYPE;
		public int INDENT;
		public int INFINITY;
		public int LANG;
		public int LANGUAGE;
		public int LETTER_VALUE;
        public int LEVEL;
        public int MATCH;
        public int MEDIA_TYPE;
        public int METHOD;
        public int MINUS_SIGN;
        public int MODE;
        public int NAME;
        public int NAMESPACE;
        public int NAN;
        public int OMIT_XML_DECLARATION;
        public int ORDER;
        public int ORDINAL;
        public int OVERRIDE;
        public int PATTERN_SEPARATOR;
        public int PERCENT;
        public int PER_MILLE;
        public int PRIORITY;
        public int REGEX;
        public int REQUIRED;
        public int RESULT_PREFIX;
		public int RULES;
        public int SELECT;
        public int SEPARATOR;
        public int SRC;
        public int STANDALONE;
		public int STRENGTH;
		public int STRING;
        public int STYLESHEET_PREFIX;
        public int TERMINATE;
        public int TEST;
        public int TUNNEL;
        public int TYPE;
        public int UNDECLARE_NAMESPACES;
        public int USE;
        public int USE_ATTRIBUTE_SETS;
        public int USE_CHARACTER_MAPS;
        public int VALIDATION;
        public int VALUE;
        public int VERSION;
		public int XPATH_DEFAULT_NAMESPACE;
        public int ZERO_DIGIT;

		public int SAXON_ASSIGNABLE;
        public int SAXON_CHARACTER_REPRESENTATION;
        public int SAXON_EXPLAIN;
        public int SAXON_INDENT_SPACES;
        public int SAXON_NEXT_IN_CHAIN;
        public int SAXON_BYTE_ORDER_MARK;
        public int SAXON_REQUIRE_WELL_FORMED;
        public int SAXON_MEMO_FUNCTION;

		public int XSL_XPATH_DEFAULT_NAMESPACE;
        public int XSL_EXCLUDE_RESULT_PREFIXES;
        public int XSL_EXTENSION_ELEMENT_PREFIXES;
        public int XSL_TYPE;
        public int XSL_USE_ATTRIBUTE_SETS;
        public int XSL_VALIDATION;
        public int XSL_VERSION;

        // specially-handled extension functions

        //public int SAXON_EVALUATE;


    public StandardNames() {
    	//pool = namePool;
    }

	public void allocateNames(NamePool pool)	{

		//XML_SPACE = 			0xfffff & pool.allocate("xml", Namespace.XML, "space");
		//XML_LANG = 				0xfffff & pool.allocate("xml", Namespace.XML, "lang");

		XSL_ANALYZE_STRING = 	0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "analyze-string");
		XSL_APPLY_IMPORTS = 	0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "apply-imports");
		XSL_APPLY_TEMPLATES = 	0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "apply-templates");
		XSL_ATTRIBUTE = 		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "attribute");
		XSL_ATTRIBUTE_SET =		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "attribute-set" );
		XSL_CALL_TEMPLATE =		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "call-template");
		XSL_CHARACTER_MAP =		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "character-map");
		XSL_CHOOSE =			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "choose");
		XSL_COMMENT = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "comment");
		XSL_COPY = 				0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "copy");
		XSL_COPY_OF = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "copy-of");
		XSL_DECIMAL_FORMAT=		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "decimal-format");
		XSL_ELEMENT =			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "element");
		XSL_FALLBACK = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "fallback");
		XSL_FOR_EACH = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "for-each");
		XSL_FOR_EACH_GROUP =	0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "for-each-group");
		XSL_FUNCTION = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "function");
		XSL_IF = 				0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "if");
		XSL_IMPORT = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "import");
		XSL_INCLUDE = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "include");
		XSL_KEY = 				0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "key");
		XSL_MATCHING_SUBSTRING=	0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "matching-substring");
		XSL_MESSAGE = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "message");
		XSL_NEXT_MATCH =		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "next-match");
		XSL_NUMBER = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "number");
		XSL_NAMESPACE =	        0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "namespace");
		XSL_NAMESPACE_ALIAS =	0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "namespace-alias");
		XSL_NON_MATCHING_SUBSTRING =
		                        0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "non-matching-substring");
		XSL_OTHERWISE = 		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "otherwise");
		XSL_OUTPUT = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "output");
		XSL_OUTPUT_CHARACTER =	0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "output-character");
		XSL_PARAM = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "param");
		XSL_PERFORM_SORT =		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "perform-sort");
		XSL_PRESERVE_SPACE =	0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "preserve-space");
		XSL_PROCESSING_INSTRUCTION =
								0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "processing-instruction");
        XSL_RESULT_DOCUMENT =   0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "result-document");
		XSL_SEQUENCE = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "sequence");
		XSL_SORT = 				0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "sort");
//		XSL_SORT_KEY = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "sort-key");
		XSL_STRIP_SPACE = 		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "strip-space");
		XSL_STYLESHEET = 		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "stylesheet");
		XSL_TEMPLATE = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "template");
		XSL_TEXT = 				0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "text");
		XSL_TRANSFORM = 		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "transform");
		XSL_VALUE_OF = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "value-of");
		XSL_VARIABLE = 			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "variable");
		XSL_WITH_PARAM = 		0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "with-param");
		XSL_WHEN = 				0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "when");

		SAXON_ASSIGN = 			0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON,  "assign");
		SAXON_CALL_TEMPLATE =   0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON,  "call-template");
		SAXON_COLLATION =		0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON,  "collation");
		SAXON_DOCTYPE = 		0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON,  "doctype");
		SAXON_ENTITY_REF =	 	0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON,  "entity-ref");
		SAXON_IMPORT_QUERY =	0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON,  "import-query");
        SAXON_SCRIPT =          0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON,  "script");
		SAXON_WHILE = 			0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON,  "while");

		ARCHIVE = 			    0xfffff & pool.allocate("", "", "archive");
		AS = 					0xfffff & pool.allocate("", "", "as");
		CASE_ORDER = 			0xfffff & pool.allocate("", "", "case-order");
		CDATA_SECTION_ELEMENTS=	0xfffff & pool.allocate("", "", "cdata-section-elements");
		CHARACTER =	            0xfffff & pool.allocate("", "", "character");
		CLASS = 				0xfffff & pool.allocate("", "", "class");
		COLLATION =				0xfffff & pool.allocate("", "", "collation");
		COPY_NAMESPACES =       0xfffff & pool.allocate("", "", "copy-namespaces");
		COUNT = 				0xfffff & pool.allocate("", "", "count");
		DATA_TYPE = 			0xfffff & pool.allocate("", "", "data-type");
		DECIMAL_SEPARATOR =		0xfffff & pool.allocate("", "", "decimal-separator");
		DEFAULT = 	        	0xfffff & pool.allocate("", "", "default");
		DECOMPOSITION = 		0xfffff & pool.allocate("", "", "decomposition");
		DIGIT = 				0xfffff & pool.allocate("", "", "digit");
		DISABLE_OUTPUT_ESCAPING=0xfffff & pool.allocate("", "", "disable-output-escaping");
		DOCTYPE_PUBLIC = 		0xfffff & pool.allocate("", "", "doctype-public");
		DOCTYPE_SYSTEM = 		0xfffff & pool.allocate("", "", "doctype-system");
		ELEMENTS = 				0xfffff & pool.allocate("", "", "elements");
		ENCODING = 				0xfffff & pool.allocate("", "", "encoding");
        ESCAPE_URI_ATTRIBUTES = 0xfffff & pool.allocate("", "", "escape-uri-attributes");
		EXCLUDE_RESULT_PREFIXES =
				 				0xfffff & pool.allocate("", "", "exclude-result-prefixes");
		EXTENSION_ELEMENT_PREFIXES =
				 				0xfffff & pool.allocate("", "", "extension-element-prefixes");
		FLAGS = 				0xfffff & pool.allocate("", "", "flags");
		FORMAT = 				0xfffff & pool.allocate("", "", "format");
		FROM = 					0xfffff & pool.allocate("", "", "from");
		GROUPING_SEPARATOR = 	0xfffff & pool.allocate("", "", "grouping-separator");
		GROUPING_SIZE = 		0xfffff & pool.allocate("", "", "grouping-size");
		GROUP_ADJACENT =    	0xfffff & pool.allocate("", "", "group-adjacent");
		GROUP_BY = 				0xfffff & pool.allocate("", "", "group-by");
		GROUP_ENDING_WITH = 	0xfffff & pool.allocate("", "", "group-ending-with");
		GROUP_STARTING_WITH = 	0xfffff & pool.allocate("", "", "group-starting-with");
		HREF = 					0xfffff & pool.allocate("", "", "href");
		ID = 					0xfffff & pool.allocate("", "", "id");
        INCLUDE_CONTENT_TYPE =  0xfffff & pool.allocate("", "", "include-content-type");
		IMPLEMENTS_PREFIX = 	0xfffff & pool.allocate("", "", "implements-prefix");
		INDENT = 				0xfffff & pool.allocate("", "", "indent");
		INFINITY = 				0xfffff & pool.allocate("", "", "infinity");
		LANG = 					0xfffff & pool.allocate("", "", "lang");
		LANGUAGE = 			    0xfffff & pool.allocate("", "", "language");
		LETTER_VALUE = 			0xfffff & pool.allocate("", "", "letter-value");
		LEVEL = 				0xfffff & pool.allocate("", "", "level");
		MATCH = 				0xfffff & pool.allocate("", "", "match");
		MEDIA_TYPE =			0xfffff & pool.allocate("", "", "media-type");
		METHOD =				0xfffff & pool.allocate("", "", "method");
		MINUS_SIGN = 			0xfffff & pool.allocate("", "", "minus-sign");
		MODE = 					0xfffff & pool.allocate("", "", "mode");
		NAME = 					0xfffff & pool.allocate("", "", "name");
		NAMESPACE = 			0xfffff & pool.allocate("", "", "namespace");
		NAN =	 				0xfffff & pool.allocate("", "", "NaN");
		OMIT_XML_DECLARATION =	0xfffff & pool.allocate("", "", "omit-xml-declaration");
		ORDER =					0xfffff & pool.allocate("", "", "order");
		ORDINAL =				0xfffff & pool.allocate("", "", "ordinal");
		OVERRIDE =  			0xfffff & pool.allocate("", "", "override");
		PATTERN_SEPARATOR =		0xfffff & pool.allocate("", "", "pattern-separator");
		PERCENT = 				0xfffff & pool.allocate("", "", "percent");
		PER_MILLE =				0xfffff & pool.allocate("", "", "per-mille");
		PRIORITY = 				0xfffff & pool.allocate("", "", "priority");
		REGEX = 		        0xfffff & pool.allocate("", "", "regex");
		REQUIRED = 		        0xfffff & pool.allocate("", "", "required");
		RESULT_PREFIX = 		0xfffff & pool.allocate("", "", "result-prefix");
		RULES = 				0xfffff & pool.allocate("", "", "rules");
		SELECT = 				0xfffff & pool.allocate("", "", "select");
		SEPARATOR =				0xfffff & pool.allocate("", "", "separator");
		SRC =        			0xfffff & pool.allocate("", "", "src");
		STANDALONE =			0xfffff & pool.allocate("", "", "standalone");
		STRENGTH = 				0xfffff & pool.allocate("", "", "strength");
		STRING = 				0xfffff & pool.allocate("", "", "string");
		STYLESHEET_PREFIX =		0xfffff & pool.allocate("", "", "stylesheet-prefix");
		TERMINATE = 			0xfffff & pool.allocate("", "", "terminate");
		TEST = 					0xfffff & pool.allocate("", "", "test");
		TUNNEL = 				0xfffff & pool.allocate("", "", "tunnel");
		TYPE = 		            0xfffff & pool.allocate("", "", "type");
        UNDECLARE_NAMESPACES =  0xfffff & pool.allocate("", "", "undeclare-namespaces");
		USE = 					0xfffff & pool.allocate("", "", "use");
		USE_ATTRIBUTE_SETS =	0xfffff & pool.allocate("", "", "use-attribute-sets");
		USE_CHARACTER_MAPS =	0xfffff & pool.allocate("", "", "use-character-maps");
		VALIDATION =     		0xfffff & pool.allocate("", "", "validation");
		VALUE = 				0xfffff & pool.allocate("", "", "value");
		VERSION = 				0xfffff & pool.allocate("", "", "version");
		ZERO_DIGIT = 			0xfffff & pool.allocate("", "", "zero-digit");

		SAXON_ASSIGNABLE =		0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON, "assignable");
        SAXON_EXPLAIN =		    0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON, "explain");
        SAXON_INDENT_SPACES =	0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON, "indent-spaces");
        SAXON_CHARACTER_REPRESENTATION =
        						0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON, "character-representation");
		SAXON_NEXT_IN_CHAIN =	0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON, "next-in-chain");
        SAXON_BYTE_ORDER_MARK =	0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON, "byte-order-mark");
        SAXON_REQUIRE_WELL_FORMED =
                                0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON, "require-well-formed");
        SAXON_MEMO_FUNCTION =	0xfffff & pool.allocate("saxon", NamespaceConstant.SAXON, "memo-function");
        XPATH_DEFAULT_NAMESPACE =
                                0xfffff & pool.allocate("", "", "xpath-default-namespace");
        XSL_XPATH_DEFAULT_NAMESPACE =
                                0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "xpath-default-namespace");
        XSL_EXCLUDE_RESULT_PREFIXES =
        						0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "exclude-result-prefixes");
        XSL_EXTENSION_ELEMENT_PREFIXES =
        						0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "extension-element-prefixes");
        XSL_TYPE =              0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "type");
        XSL_USE_ATTRIBUTE_SETS =
        						0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "use-attribute-sets");
        XSL_VALIDATION =        0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "validation");
        XSL_VERSION =			0xfffff & pool.allocate("xsl", NamespaceConstant.XSLT, "version");

        //SAXON_EVALUATE =        0xfffff & pool.allocate("saxon", Namespace.SAXON, "evaluate");
	}

	/**
	* Utility routine to generate Java constants for the standard names used in
	* the stylesheet
	*/

	//public static void main(String[] args) {
	//	NamePool pool = NamePool.getDefaultNamePool();
	//	pool.generateJavaConstants();
	//}

	// TODO: Rather than allocating the fixed name codes dynamically at the start of each transformation,
	// generate Java code to do it directly.

}
